local sources = {
	{ "clan", "1736451", "AFH" },
	{ "clan", "1736457", "AFHk" },
	{ "clan", "1736458", "AFHobo" },
}

--~ local contact_color = get_character_state("kol.account.contact chat color") -- TODO-future: can these be moved to chat state?
--~ local contacts = get_character_state("kol.account.contact list")
--~ if (contacts == "") then contacts = {} else contacts = str_to_table(contacts) end

contacts = {}

local function get_contact_color(name, id, default)
-- 	print("color!", id, contacts[id], default, contact_color)
	if contact_color ~= "" and contacts[id] then
		return [["]]..contact_color..[["]]
	end
	return default
end

function lookup_player_id(inputname) -- chat cannot use character state
	if inputname:len() > 20 then
		if inputname:sub(20, 20) == " " then
-- 			print("transforming", inputname)
			inputname = inputname:sub(1, 19) .. inputname:sub(21)
-- 			print("  to", inputname)
		end
	end
	local name = inputname:lower()
	local tbl = get_chat_state("kol.player ids")
	if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
	if not tbl[name] then
		local id = get_player_id(name)
		if id == "-1" then
			return "-123"
		else
			tbl[name] = id
			set_chat_state("kol.player ids", table_to_str(tbl))
		end
	end
-- 	print("lookup_player_id.", inputname, tbl[name])
	return tbl[name], inputname
end

local function do_replacement(chatmsg, test)
	local preid, precolor, chatcolor, prename, premsg, msg, after = string.match(chatmsg, test)
	if after then
		local id = lookup_player_id(name)
		chatmsg = prename..id..mid..get_contact_color(string.lower(name), id, color)..premsg..name..w..msg..after
		replaced = true
	end
	return chatmsg
end

add_chat_printer(function (chatmsg)
	for a, b in pairs(sources) do -- TODO-future: revisit these regexes
		local function replace(chatmsg, firsttest, test)
			local prefix, preid, precolor, chatcolor, prename, premsg, msg = string.match(chatmsg, firsttest)
			if msg then
				local name, msgtext = string.match(msg, test)
				if name and msgtext then
					local id, newname = lookup_player_id(name)
					local color = get_contact_color(newname:lower(), id, chatcolor)
					chatmsg = prefix .. preid .. id .. precolor .. color .. prename .. newname .. premsg .. msgtext
				end
			end
			return chatmsg
		end
		-- normal text
		local bigtest = [[^(.-)(<b><a target=mainpane href="showplayer%.php%?who=)]]..b[2]..[[("><font color=)([^>]-)(>)]]..b[3]..[[(</font></b></a>: )(.+)$]]
		chatmsg = replace(chatmsg, bigtest, "^%(([^*].-)%) (.-)$")
		chatmsg = replace(chatmsg, bigtest, "^%[([^*].-)%] (.-)$")
		chatmsg = replace(chatmsg, bigtest, "^{([^*].-)} (.-)$")

		-- emote text
		local bigtest = [[^(.-)(<b><i><a target=mainpane href="showplayer%.php%?who=)]]..b[2]..[[("><font color=)([^>]-)(>)]]..b[3]..[[(</b></font></a> )(.+)$]]
		chatmsg = replace(chatmsg, bigtest, "^%(([^*].-)%) (.-)$")
		chatmsg = replace(chatmsg, bigtest, "^%[([^*].-)%] (.-)$")
		chatmsg = replace(chatmsg, bigtest, "^{([^*].-)} (.-)$")
	end
	return chatmsg
end)

-- local custom_colors = get_character_state("kol.custom chat colors")
-- if (custom_colors == "") then custom_colors = {} else custom_colors = str_to_table(custom_colors) end
-- 
-- for name, color in pairs(custom_colors) do
-- 	text = string.gsub(text, "(<font color=[^>]->%[.-%]</font> <b><a target=mainpane href=\"showplayer%.php%?who=[0-9]-\"><font color=)([^>]-)(>"..name.."</font></b></a>: )", "%1"..color.."%3")
-- 	text = string.gsub(text, "(<font color=[^>]->%[.-%]</font> <b><i><a target=mainpane href=\"showplayer%.php%?who=[0-9]-\"><font color=)([^>]-)(>"..name.."</b></font></a> )", "%1"..color.."%3")
-- end
